/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataUpcloudManagedObjectStoragePoliciesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/upcloudltd/upcloud/5.2.2/docs/data-sources/managed_object_storage_policies#id DataUpcloudManagedObjectStoragePolicies#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Service UUID.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/upcloudltd/upcloud/5.2.2/docs/data-sources/managed_object_storage_policies#service_uuid DataUpcloudManagedObjectStoragePolicies#service_uuid}
    */
    readonly serviceUuid: string;
}
export interface DataUpcloudManagedObjectStoragePoliciesPolicies {
}
export declare function dataUpcloudManagedObjectStoragePoliciesPoliciesToTerraform(struct?: DataUpcloudManagedObjectStoragePoliciesPolicies): any;
export declare function dataUpcloudManagedObjectStoragePoliciesPoliciesToHclTerraform(struct?: DataUpcloudManagedObjectStoragePoliciesPolicies): any;
export declare class DataUpcloudManagedObjectStoragePoliciesPoliciesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataUpcloudManagedObjectStoragePoliciesPolicies | undefined;
    set internalValue(value: DataUpcloudManagedObjectStoragePoliciesPolicies | undefined);
    get arn(): string;
    get attachmentCount(): number;
    get createdAt(): string;
    get defaultVersionId(): string;
    get description(): string;
    get document(): string;
    get name(): string;
    get serviceUuid(): string;
    get systemAttribute(): cdktf.IResolvable;
    get updatedAt(): string;
}
export declare class DataUpcloudManagedObjectStoragePoliciesPoliciesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataUpcloudManagedObjectStoragePoliciesPoliciesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/upcloudltd/upcloud/5.2.2/docs/data-sources/managed_object_storage_policies upcloud_managed_object_storage_policies}
*/
export declare class DataUpcloudManagedObjectStoragePolicies extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "upcloud_managed_object_storage_policies";
    /**
    * Generates CDKTF code for importing a DataUpcloudManagedObjectStoragePolicies resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataUpcloudManagedObjectStoragePolicies to import
    * @param importFromId The id of the existing DataUpcloudManagedObjectStoragePolicies that should be imported. Refer to the {@link https://registry.terraform.io/providers/upcloudltd/upcloud/5.2.2/docs/data-sources/managed_object_storage_policies#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataUpcloudManagedObjectStoragePolicies to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/upcloudltd/upcloud/5.2.2/docs/data-sources/managed_object_storage_policies upcloud_managed_object_storage_policies} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataUpcloudManagedObjectStoragePoliciesConfig
    */
    constructor(scope: Construct, id: string, config: DataUpcloudManagedObjectStoragePoliciesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _policies;
    get policies(): DataUpcloudManagedObjectStoragePoliciesPoliciesList;
    private _serviceUuid?;
    get serviceUuid(): string;
    set serviceUuid(value: string);
    get serviceUuidInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
